import router from "./router";
import store from "./store";
import { Message } from "element-ui";
import NProgress from "nprogress";
import "nprogress/nprogress.css";
import { getToken, getCompanyId } from "@/utils/auth";
import { isRelogin, getButtonLish } from "@/utils/request";

NProgress.configure({
  showSpinner: false,
});

const whiteList = [
  "/login",
  "/test",
  "/auth-redirect",
  "/bind",
  "/contractAssistant",
  "/register",
  "/systemInit",
  "/databaseLogin",
];

router.beforeEach((to, from, next) => {
  NProgress.start();
  if (getToken()) {
    to.meta.title && store.dispatch("settings/setTitle", to.meta.title);
    /* has token*/
    if (to.path === "/login") {
      next({
        path: "/",
      });
      NProgress.done();
    } else {
      let routeList = localStorage.getItem("routeList")
        ? localStorage.getItem("routeList")
        : null;
      // store.dispatch("GenerateRoutes").then((accessRoutes) => {
      //  next()
      // })
      if (store.getters.permission_routes.length == 0) {

        store.dispatch("GenerateRoutes").then((accessRoutes) => {
          // 根据roles权限生成可访问的路由表
          // for (let i = 0, length = accessRoutes.length; i < length; i += 1) {
          //   const element = accessRoutes[i];
          //   // router.addRoutes(accessRoutes); // 动态添加可访问路由表
          // }
          router.addRoutes(accessRoutes); // 动态添加可访问路由表

          // router.addRoutes(accessRoutes) // 动态添加可访问路由表
          localStorage.setItem("routeList", JSON.stringify(accessRoutes));
          next({
            ...to,
            replace: true,
          }); // hack方法 确保addRoutes已完成
        });
      } else {
        next();
      }
    }
  } else {
    // 没有token
    if (whiteList.indexOf(to.path) !== -1) {
      // 在免登录白名单，直接进入
      next();
    } else {
      next(`/login?redirect=${to.fullPath}`); // 否则全部重定向到登录页
      NProgress.done();
    }
  }
});

router.afterEach(() => {
  NProgress.done();
});
